#! /bin/sh
#
# Copyright (c) 2005 International Business Machines Corporation.
# All rights reserved.

# Description:      Starts the IBM ServeRAID Manager GUI.
# Author:           Sriprasad Bhat K 02/12/2005.

unset JAVA_HOME CLASSPATH JFLAGS 

OS=`uname -s`
case $OS in
   "UnixWare")
	   INSTDIR=/opt/RaidMan
           if [ -d /usr/java2 ]; then      
	      JAVA_HOME=/usr/java2
	   elif [ -d /usr/jre2 ]; then       
	      JAVA_HOME=/usr/jre2
	   elif [ -d /usr/java ]; then      
	      JAVA_HOME=/usr/java
           elif [ -d /usr/jre ]; then 
	      JAVA_HOME=/usr/jre
	   fi
           THREADS_FLAG=native 
           JAVA_COMPILER=NONE
           JFLAGS="-mx192m -ms8m"
           export JAVA_COMPILER JFLAGS
	   ;;
   "OpenUNIX")
      	   INSTDIR=/opt/RaidMan
           if [ -d /usr/java2 ]; then	
	      JAVA_HOME=/usr/java2
	   elif [ -d /usr/jre2 ]; then       
	      JAVA_HOME=/usr/jre2
	   elif [ -d /usr/java ]; then      
	      JAVA_HOME=/usr/java
           elif [ -d /usr/jre ]; then  
	      JAVA_HOME=/usr/jre
	   fi
           THREADS_FLAG=native 
           JAVA_COMPILER=NONE
           JFLAGS="-mx192m -ms8m"
           export JAVA_COMPILER JFLAGS
	   ;;
   "SCO_SV" )   
	   INSTDIR=/opt/RaidMan
           if [ -d /usr/java2 ]; then      
	      JAVA_HOME=/usr/java2
	   elif [ -d /usr/jre2 ]; then	
	      JAVA_HOME=/usr/jre2
	   elif [ -d /usr/java ]; then	
	      JAVA_HOME=/usr/java
           elif [ -d /usr/jre ]; then  
	      JAVA_HOME=/usr/jre
	   fi
	   # THREADS_FLAG=green    
           JAVA_COMPILER=NONE
           JFLAGS="-mx192m -ms8m"
           export JAVA_COMPILER JFLAGS
	   ;;
   "Linux")
	   INSTDIR=/usr/RaidMan
           Arch=`uname -m` 
           if [ "$Arch" = "ia64" ];then 
	      JAVA_HOME="./IBMJava2-ia64-13"
  	   else 	   
       	      JAVA_HOME="."
           fi        
           JAVA_BIN=$JAVA_HOME/jre/bin
           JAVA_LIB=$JAVA_HOME/jre/lib
           # load LSI ioctl module if necessary
           if /sbin/lsmod | grep "^mptctl" > /dev/null 2>&1
           then
              :
           else
              /sbin/modprobe mptctl > /dev/null 2>&1
           fi
           # make the device node if it's not there
           if /bin/ls /dev/mptctl > /dev/null 2>&1
           then
              :
           else
              /bin/mknod /dev/mptctl c 10 220 > /dev/null 2>&1
           fi
           ;;
	"SunOS")
		INSTDIR=/usr/RaidMan
		Arch=`uname -m` 
		if [ "$Arch" = "i86pc" ];then
			JAVA_HOME="."
			JAVA_BIN=$JAVA_HOME/jre/bin
			JAVA_LIB=$JAVA_HOME/jre/lib
		else
			echo "IBM ServeRAID Manager is supported only on Solaris x86"
			exit 1
		fi
esac

if [ ! "$JAVA_BIN" ]; then
  JAVA_BIN=$JAVA_HOME/bin
fi

if [ ! "$JAVA_LIB" ]; then
  JAVA_LIB=$JAVA_HOME/lib
fi

LD_LIBRARY_PATH=$INSTDIR:$LD_LIBRARY_PATH
export LD_LIBRARY_PATH JAVA_HOME JAVA_BIN JAVA_LIB CLASSPATH THREADS_FLAG 

cd $INSTDIR

if [ "$OS" = "Linux" ]; then
   $JAVA_BIN/java -Djava.compiler=NONE -cp $INSTDIR/RaidMan.jar com.ibm.sysmgt.raidmgr.mgtGUI.Launch $* 
fi

if [ "$OS" = "SunOS" ]; then
   $JAVA_BIN/java -Djava.compiler=NONE -cp $INSTDIR/RaidMan.jar com.ibm.sysmgt.raidmgr.mgtGUI.Launch $* 
else
   if [ -f $JAVA_BIN/java ]; then
      $JAVA_BIN/java $JFLAGS -classpath $INSTDIR/RaidMan.jar:$JAVA_LIB/classes.zip com.ibm.sysmgt.raidmgr.mgtGUI.Launch $* </dev/null
   else
      $JAVA_BIN/jre $JFLAGS -nojit -cp $INSTDIR/RaidMan.jar -cp $JAVA_LIB/classes.zip com.ibm.sysmgt.raidmgr.mgtGUI.Launch $* </dev/null
   fi
fi


